from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="StackCreateBody")


@_attrs_define
class StackCreateBody:
    """
    Attributes:
        stack_path (str): Path for the stack (directory components separated with /)
        base_stack (str | Unset): MongoDB ObjectId
        inherit_sharing_from (str | Unset): Stack path to inherit sharing settings from
    """

    stack_path: str
    base_stack: str | Unset = UNSET
    inherit_sharing_from: str | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        stack_path = self.stack_path

        base_stack = self.base_stack

        inherit_sharing_from = self.inherit_sharing_from

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "stackPath": stack_path,
            }
        )
        if base_stack is not UNSET:
            field_dict["baseStack"] = base_stack
        if inherit_sharing_from is not UNSET:
            field_dict["inheritSharingFrom"] = inherit_sharing_from

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        stack_path = d.pop("stackPath")

        base_stack = d.pop("baseStack", UNSET)

        inherit_sharing_from = d.pop("inheritSharingFrom", UNSET)

        stack_create_body = cls(
            stack_path=stack_path,
            base_stack=base_stack,
            inherit_sharing_from=inherit_sharing_from,
        )

        stack_create_body.additional_properties = d
        return stack_create_body

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
